Imports ZylGPSReceiverMobile

Public Class FormMain

    ' This delegate enables asynchronous calls for setting
    ' the text property on a TextBox control.
    Private Delegate Sub SetTextCallback(ByVal text As String)

    Private Sub SetTextBoxOut(ByVal text As String)
        Try

            ' InvokeRequired required compares the thread ID of the
            ' calling thread to the thread ID of the creating thread.
            ' If these threads are different, it returns true.
            If Me.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf SetTextBoxOut)
                Me.Invoke(d, New Object() {[text]})
                Return
            End If

            Me.textBoxOut.Text &= text
            Me.textBoxOut.SelectionStart = textBoxOut.Text.Length
            Me.textBoxOut.SelectionLength = 0
            Me.textBoxOut.ScrollToCaret()
        Catch
            Me.textBoxOut.Text = String.Empty
        End Try
    End Sub

    Private Sub SetTextBoxCoord(ByVal text As String)
        Try
            ' InvokeRequired required compares the thread ID of the
            ' calling thread to the thread ID of the creating thread.
            ' If these threads are different, it returns true.
            If (Me.InvokeRequired) Then
                Dim d As New SetTextCallback(AddressOf SetTextBoxCoord)

                Me.Invoke(d, New Object() {[text]})
                Return

            End If
            Me.textBoxCoord.Text = text
        Catch
        End Try
    End Sub

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        If lstPorts.SelectedIndex >= 0 Then
            cmpGpsReceiver.Port = CType(lstPorts.SelectedIndex + 1, SerialCommPort)

            If Not cmpGpsReceiver.Open() Then
                MessageBox.Show("Cannot open.")
            End If
        End If
    End Sub
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        cmpGpsReceiver.Close()
    End Sub

    Private Sub cmpGpsReceiver_Received(ByVal sender As System.Object, ByVal e As ZylGPSReceiverMobile.DataEventArgs) Handles cmpGpsReceiver.Received
        Dim str As String
        str = "Lat: " & cmpGpsReceiver.Position.GetLatitudeAsDecimalDegrees().ToString() & " "
        str &= "Long: " & cmpGpsReceiver.Position.GetLongitudeAsDecimalDegrees().ToString() & " "
        str &= "Alt: " & cmpGpsReceiver.Position.Altitude.ToString() & " "
        str &= "Speed: " & cmpGpsReceiver.Position.Speed_KMH.ToString()
        SetTextBoxCoord(str)
        SetTextBoxOut(e.Buffer)
    End Sub

    Private Sub cmpGpsReceiver_Connected(ByVal sender As System.Object, ByVal e As ZylGPSReceiverMobile.ConnectionEventArgs) Handles cmpGpsReceiver.Connected
        SetTextBoxOut("Connected to: " & e.Port.ToString())
    End Sub

    Private Sub cmpGpsReceiver_Disconnected(ByVal sender As System.Object, ByVal e As ZylGPSReceiverMobile.ConnectionEventArgs) Handles cmpGpsReceiver.Disconnected
        SetTextBoxOut("Disconnected from: " & e.Port.ToString())
    End Sub
End Class
